/* Copyright 1998 Sam Trenholme
   This code is released to the public domain. */

#include <stdio.h>
#include <sys/types.h>
#include "kiwi.h"

char b32map[] = MAPPING;

/* routine so other programs can also access the binary->ascii map */
char map32(int number)
        {
        return b32map[number];
        }

/* routine to convert a 32-bit dinary data in to a 7-character ASCII string */

/* The string `string' has to be preallocated */

/* returns a pointer to the string */

char *cryptdate(u_int32_t data, char *string)
{

        u_int32_t shift;
	u_int8_t parity;

	int counter;

	/* Calculate the 3-bit parity of the plaintext */
	parity = 0;
	shift = data;
	for(counter = 0; counter < 11; counter++)
		{
		parity ^= shift & 0x07;
		shift >>= 3;
		}

	/* Do the actual encryption */

	shift = scramble(data);
	
	/* prepare the parity to add to the encrypted text */

	parity <<= 2;

        for(counter=0;counter<7;counter++)
                {
		if(counter == 6)
			shift |= parity;
		string[counter] = b32map[shift & 31];
                shift >>= 5;
                }

	string[7] = 0;

	return string;

}

