/* Copyright 1998 Sam Trenholme
   This code is released to the public domain. */

#include <stdio.h>
#include <sys/types.h>
#include "kiwi.h"

int 
main(int argc, char **argv)
{

        int counter, ssi=0;

	char crypto[7];
	u_int32_t data;

	u_int32_t ip;
	u_int8_t ipo[4];
	char input[BUFMAX], *copy, *bookmark, *copystart;

	/* If we do not get an argument on the command line, see if this
           is being run from inside an SSI, and, if so, run it as an SSI */

	if(argc != 2)
		{
		/* Get the ip we want to encrypt from the environmental
 		   variable web servers set up before running a SSI or CGI */
		copy=(char *)getenv("REMOTE_ADDR");
		/* Set a flag to not add a line feed to the output, so 
                   as to not hoze email addresses with embedded ssi cookies */
		ssi = 1;
		/* If we did not get an IP to encrypt, tell the user how to
  		   give us an IP on the command line, and exit w/ error */
		if(!copy) 
			{
			fprintf(stderr,
		  	  "Usage: ipcrypt IP\nexample: ipcrypt 127.0.0.1\n");
			exit(1);
			}
		/* A security precaution, just in case people are trying to
                   get a buffer overflow */
		if(strlen(copy) >= BUFMAX || strlen(copy) <= 0)
			{
			fprintf(stderr,"Out of bound input discarded.\n");
			exit(1);
			}
		}
	else	
		{
		if(strlen(argv[1]) >= BUFMAX || strlen(argv[1]) <= 0)
			{
			fprintf(stderr,"Out of bound input discarded.\n");
			exit(2);
			}
		copy = argv[1];
		}

	copystart = copy;

	/* Convert a string like 11.22.33.44 in a 4-element array with
           elements {11,22,33,44} */

	for(counter=0;counter<4;counter++)
		{
		bookmark=input;
		while(bookmark < input + BUFMAX && *copy > 32 && *copy != '.'
                      && copy < copystart + BUFMAX)
			*bookmark++ = *copy++;
		if(bookmark < input + BUFMAX)
			*bookmark = 0;
		if(*copy == '.')
			copy++;
		sscanf(input,"%d",(int *)&ipo[counter]);
		}

	/* Convert the four-element array in to a single 32-bit number */

	ip = (ipo[0] << 24) | (ipo[1] << 16) | (ipo[2] << 8) | ipo[3];

	data = 0xC0000000; /* 1100 indicates ip address right shifted 4 bits */
	data |= (ip & 0xFFFFFFFF) >> 4; 

	/* Convert the number in to an ASCII encrypted cookie */
	printf("%s",cryptdate(data,crypto));

	if(!ssi)
        	printf("\n");

}

