/* Copyright 1998 Sam Trenholme
   This code is released to the public domain. */

#include <sys/types.h>
#include "config.h"

typedef struct 
	{
	int format;
	u_int32_t data;
	} message;

/* The format types for the data */
#define FORMAT_INVALID 0
#define FORMAT_SHORT_TIMEOUT 1 /* Short timeout */
#define FORMAT_MID_TIMEOUT 2   /* Medium timeout */
#define FORMAT_LONG_TIMEOUT 3  /* Long timeout */
#define FORMAT_SUBJECT_HASH 4  /* Hash of subject line + timestamp */
#define FORMAT_IP_BLOCK 5 /* 16-block IP range */
#define FORMAT_HIDDEN_DIR 6 /* timestamp that changes hourly for moving
                               hidden directories */
#define FORMAT_FIVE_LETTERS 7 /* five letter code for permanent addresses we
                                 only give to one party */
#define FORMAT_BAD_PARITY 1001 /* bad parity */

/* The map for binary-to-ascii conversion */
#define MAPPING "abcdefghijklmnopqrstuvwxyz234567"

/* Maximum length for strings (I have gone to some effort to remove
   buffer overflows) */
#define BUFMAX 256

/* Character used to separate sections of email addresses.  In newer
   versions of sendmail, this is a '+'.  In Qmail, it is a '-' */
#ifdef QMAIL
#define DASH '-'
#else
#define DASH '+'
#endif

