/* Copyright 1998 Sam Trenholme
   This code is released to the public domain. */

#include <stdio.h>
#include <sys/types.h>
#define USE_MAP32 
#include "kiwi.h"

int 
main(int argc, char **argv)
{

        int counter, index;

	char crypto[7];
	u_int32_t data;

	u_int32_t shift;

	u_int32_t msg;
	char *copy, *copystart;

	copy = 0;

	/* If we did not specify the five-letter string to encrypt on
           the command line, exit */
	if(argc != 2)
		{
		/* The !copy check is here just in case we want to add code 
                   to look at the standard input, etc. later */
		if(!copy) 
			{
			fprintf(stderr,
		  	  "Usage: msgcrypt message\nexample: ipcrypt abcde\n");
			exit(1);
			}
		}
	else	
		{
		/* security check to make sure that the input is not
                   too long */
		if(strlen(argv[1]) >= BUFMAX || strlen(argv[1]) <= 0)
			{
			fprintf(stderr,"Out of bound input discarded.\n");
			exit(2);
			}
		/* If everything looks ok, we set "copy" (the pointer that
		   we use for scanning and converting a five-letter message)
		   to be the beginning of the first command-line argument */
		copy = argv[1];
		}

	copystart = copy;
	shift = 0;

	/* convert the five-letter string in to 25 bits of binary data */
	for(counter=0;counter<5;counter++)
		{
		int good;
		good = 0;
	
		shift <<= 5;

		/* What we do is go through the entire 32-character possible
		   mappings (where 0 is 'a', 1 is 'b', and so on), and 
                   see if the character we are looking at has a mapping */

		/* For all possible 5-bit mappings */
		for(index=0;index<32;index++)
			/* If the character we are looking at is our mapping */
			if(copy[counter] == map32(index))
				{
				/* Then we make the low five bits the value
				   of the mapping in question */
				shift |= index;
				/* We currently only allow 100% alphabetic
				   (a-z) messages.  The other six positions
				   are reserved for future use (space, other
				   formats, etc.) */
				if(index<26)
					good = 1;
				}
		/* If the user attemps to encrypt an invalid (currently
                   anything non-alphabetic) message, we exit with an
		   "Invalid Message" error */
		if(good == 0)
			{
			fprintf(stderr,"Invalid message\n");
			exit(-2);
			}
		}

	/* We take the five letter message, and prepend it with a
	   "0111110" (7C) 7-bit header */
	data = 0x7C000000; /* 5-letter message */
	data |= (shift & 0x01FFFFFF); 

	/* We make the output available on the standard output */
        printf("%s\n",cryptdate(data,crypto));

}

